#define output(directions,pin) (directions |= pin) // set port direction for output
#define set(port,pin) (port |= pin) // set port pin
#define clear(port,pin) (port &= (~pin)) // clear port pin

#define led_delay() _delay_ms(100) // LED flash delay
#define led_delay_receive() _delay_ms(800) // LED flash delay

#define led_port PORTB
#define led_direction DDRB
#define led_pin (1 << PB4) //Pin IO8


#define node_id '0'

void flash() {
   //
   // LED flash delay
   //
   clear(led_port, led_pin);
   led_delay();
   set(led_port, led_pin);
   }

int message;

void setup() {
  // put your setup code here, to run once:
  
   Serial.begin(9600);
   Serial1.begin(9600);
   //
   // set clock divider to /1
   //
   CLKPR = (1 << CLKPCE);
   CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
   //
   // initialize output pins
   //
   set(led_port, led_pin);
   output(led_direction, led_pin);
}

void loop() {
  // put your main code here, to run repeatedly:

  flash();
  

  if (Serial.available() > 0) {
    
    // read the incoming byte:
    message = Serial.read();
    Serial1.write(message);
    
    led_delay();
 
    (PORTB &= (~(1 << PB4))); //Turn off the LED
    
    if (Serial1.available() > 0) {
       String chr = Serial1.readString();
       Serial.println(chr);
       }
    
    flash();

    if (message == node_id) {
       Serial.print(" -> node: ");
       Serial.write(message);
       led_delay_receive();
       }

    (PORTB &= (~(1 << PB4))); //Turn off the LED
       
  }
}
